(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[13],{

/***/ 2054:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.namespace('Tine.GDPR');
Tine.GDPR.Application = Ext.extend(Tine.Tinebase.Application, {
  hasMainScreen: false,

  /**
   * Get translated application title of the GDPR App
   *
   * @return {String}
   */
  getTitle: function getTitle() {
    return this.i18n._('GDPR');
  },
  // @TODO this should really autoregister
  registerCoreData: function registerCoreData() {
    Tine.log.info('Tine.GDPR.Application - registering core data ... ');
    Tine.CoreData.Manager.registerGrid('GDPR_Model_DataProvenance', Tine.GDPR.DataProvenanceGridPanel);
    Tine.CoreData.Manager.registerGrid('GDPR_Model_DataIntendedPurpose', Tine.GDPR.DataIntendedPurposeGridPanel);
  }
});

/***/ }),

/***/ 2055:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.GDPR.Addressbook'); // NOTE: Contact model is still defined manually

Tine.Addressbook.Model.Contact.prototype.fields.add(new Ext.data.Field({
  name: 'GDPR_DataIntendedPurposeRecord',
  label: 'GDPR Intended Purpose',
  group: 'GDPR',
  omitDuplicateResolving: true
} // i18n._('GDPR Intended Purpose')
));
Tine.Addressbook.Model.Contact.prototype.fields.add(new Ext.data.Field({
  name: 'GDPR_Blacklist',
  label: 'GDPR Blacklisted',
  group: 'GDPR'
} // i18n._('GDPR Blacklisted')
));
Tine.Addressbook.Model.Contact.prototype.fields.add(new Ext.data.Field({
  name: 'GDPR_DataProvenance',
  label: 'GDPR Data Provenance',
  group: 'GDPR'
}));
Tine.Addressbook.Model.Contact.prototype.fields.add(new Ext.data.Field({
  name: 'GDPR_DataEditingReason',
  label: 'GDPR Data Editing Reason',
  group: 'GDPR'
}));
Tine.Addressbook.Model.Contact.prototype.fields.add(new Ext.data.Field({
  name: 'GDPR_DataExpiryDate',
  label: 'GDPR Data Expiry Date',
  group: 'GDPR'
})); // Tine.Addressbook.contactBackend is created on code include time

delete Tine.Addressbook.contactBackend.getReader().ef;
Tine.Addressbook.contactBackend.getReader().buildExtractors();
Tine.widgets.grid.FilterRegistry.register('Addressbook', 'Contact', {
  filtertype: 'foreignrecord',
  foreignRecordClass: 'GDPR.DataIntendedPurposeRecord',
  foreignRefIdField: 'intendedPurpose',
  linkType: 'foreignId',
  filterName: 'GDPRDataIntendedPurposeFilter',
  ownField: 'GDPR_DataIntendedPurposeRecord',
  // i18n._('GDPR Intended Purpose')
  label: 'GDPR Intended Purpose'
});
Tine.widgets.grid.FilterRegistry.register('Addressbook', 'Contact', {
  valueType: 'bool',
  filterName: 'GDPRDataBlacklist',
  field: 'GDPR_Blacklist',
  // i18n._('GDPR Blacklisted')
  label: 'GDPR Blacklisted'
});

/***/ }),

/***/ 2056:
/***/ (function(module, exports, __webpack_require__) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
__webpack_require__(2057);

__webpack_require__(2059);

Ext.ns('Tine.GDPR.Addressbook');

Tine.GDPR.Addressbook.EditDialogPlugin = function () {};

Tine.GDPR.Addressbook.EditDialogPlugin.prototype = {
  contactEditDialog: null,
  app: null,
  init: function init(cmp) {
    this.contactEditDialog = cmp;
    this.app = Tine.Tinebase.appMgr.get('GDPR'); // intercept save contact

    cmp.on('save', this.onBeforeSave, this);
  },
  onBeforeSave: function onBeforeSave(cmp, record, ticketFn) {
    var resolve = ticketFn();
    var window = Tine.GDPR.Addressbook.DataProvenanceDialog.openWindow({
      listeners: {
        scope: this,
        beforeapply: this.onBeforeApplyProvenanceDialog
      }
    });
    window.on('beforeclose', this.onBeforeCloseProvenanceDialog.createDelegate(this, [resolve]), this);
  },
  validateDataProvenance: function validateDataProvenance() {
    var mandatoryConfig = Tine.Tinebase.configManager.get('dataProvenanceADBContactMandatory', 'GDPR');
    return !!(mandatoryConfig != 'yes' || this.contactEditDialog.record.get('GDPR_DataProvenance'));
  },
  onBeforeApplyProvenanceDialog: function onBeforeApplyProvenanceDialog(data) {
    var _ = window.lodash,
        me = this;

    _.each(data, function (v, k) {
      if (v) {
        me.contactEditDialog.record.set(k, v);
      }
    });

    return me.validateDataProvenance();
  },

  onBeforeCloseProvenanceDialog(resolve) {
    var _ = window.lodash,
        me = this;

    if (!me.validateDataProvenance()) {
      return false;
    }

    resolve();
  }

};
Ext.preg('Tine.GDPR.Addressbook.EditDialogPlugin', Tine.GDPR.Addressbook.EditDialogPlugin);
Ext.ux.pluginRegistry.register('/Addressbook/EditDialog/Contact', Tine.GDPR.Addressbook.EditDialogPlugin);

/***/ }),

/***/ 2057:
/***/ (function(module, exports, __webpack_require__) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.GDPR.Addressbook');

__webpack_require__(2058);

Tine.GDPR.Addressbook.DataProvenanceDialog = Ext.extend(Tine.Tinebase.dialog.Dialog, {
  labelAlign: 'top',
  layout: 'form',
  frame: false,
  canonicalName: ['Addressbook', 'EditDialog', 'Contact', 'DataProvenanceDialog'].join(Tine.Tinebase.CanonicalPath.separator),
  initComponent: function initComponent() {
    this.app = Tine.Tinebase.appMgr.get('GDPR');
    var dataProvenanceMandatory = Tine.Tinebase.configManager.get('dataProvenanceADBContactMandatory', 'GDPR');
    this.items = [Tine.widgets.form.RecordPickerManager.get('GDPR', 'DataProvenance', {
      fieldLabel: this.app.i18n._('Data Provenance'),
      allowBlank: dataProvenanceMandatory !== 'yes',
      name: 'GDPR_DataProvenance',
      anchor: '100%',
      value: dataProvenanceMandatory == 'default' ? Tine.Tinebase.configManager.get('defaultADBContactDataProvenance', 'GDPR') : ''
    }), {
      xtype: 'textfield',
      fieldLabel: this.app.i18n._('Reason for Editing'),
      name: 'GDPR_DataEditingReason',
      maxLength: 255,
      anchor: '100%',
      emptyText: this.app.i18n._('Please enter the reason for editing this data')
    }];
    this.items = [{
      layout: 'form',
      style: 'padding: 5px;',
      border: false,
      items: this.items
    }];
    Tine.GDPR.Addressbook.DataProvenanceDialog.superclass.initComponent.call(this);
  },
  onButtonCancel: Tine.Tinebase.dialog.Dialog.prototype.onButtonApply,
  getEventData: function getEventData() {
    this.getForm().isValid();
    return this.getForm().getFieldValues();
  },
  getCanonicalPathSegment: function getCanonicalPathSegment() {
    return ['', this.app.appName, this.canonicalName].join(Tine.Tinebase.CanonicalPath.separator);
  }
});

Tine.GDPR.Addressbook.DataProvenanceDialog.openWindow = function (config) {
  var window = Tine.WindowFactory.getWindow({
    title: Tine.Tinebase.appMgr.get('GDPR').i18n._('Please Confirm the Data Provenance'),
    closeAction: 'close',
    modal: true,
    width: 550,
    height: 200,
    layout: 'fit',
    plain: true,
    items: new Tine.GDPR.Addressbook.DataProvenanceDialog(config)
  });
  return window;
};

/***/ }),

/***/ 2058:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.GDPR.Addressbook');
Tine.GDPR.Addressbook.DataProvenancePicker = Ext.extend(Tine.Tinebase.widgets.form.RecordPickerComboBox, {
  initComponent: function initComponent() {
    this.recordClass = Tine.GDPR.Model.DataProvenance;
    this.recordProxy = Tine.GDPR.dataprovenanceBackend;
    Tine.GDPR.Addressbook.DataProvenancePicker.superclass.initComponent.call(this);
  },
  // add expired btn
  initList: function initList() {
    Tine.GDPR.Addressbook.DataProvenancePicker.superclass.initList.apply(this, arguments);

    if (this.pageTb && !this.showExpired) {
      this.showExpiredBtn = new Ext.Button({
        text: this.app.i18n._('Show expired'),
        iconCls: 'action_showArchived',
        enableToggle: true,
        pressed: this.showExpired,
        scope: this,
        handler: function handler() {
          this.showExpired = this.showExpiredBtn.pressed;
          this.store.load();
        }
      });
      this.pageTb.add('-', this.showExpiredBtn);
      this.pageTb.doLayout();
    }
  },
  // append showExpired value
  onBeforeLoad: function onBeforeLoad(store, options) {
    Tine.GDPR.Addressbook.DataProvenancePicker.superclass.onBeforeLoad.apply(this, arguments);

    if (this.showExpiredBtn) {
      Ext.each(store.baseParams.filter, function (filter, idx) {
        if (filter.field == 'expiration') {
          store.baseParams.filter.remove(filter);
        }
      }, this);

      if (!this.showExpiredBtn.pressed) {
        store.baseParams.filter.push({
          field: "expiration",
          operator: "after",
          value: new Date()
        });
      }
    }
  }
});
Tine.widgets.form.RecordPickerManager.register('GDPR', 'DataProvenance', Tine.GDPR.Addressbook.DataProvenancePicker);

/***/ }),

/***/ 2059:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.GDPR.Addressbook');
Tine.GDPR.Addressbook.ContactGDPRPanel = Ext.extend(Ext.Panel, {
  layout: 'fit',
  border: false,
  requiredGrant: 'editGrant',
  canonicalName: ['Addressbook', 'EditDialog', 'Contact', 'GDPRPanel'].join(Tine.Tinebase.CanonicalPath.separator),
  initComponent: function initComponent() {
    this.app = this.app || Tine.Tinebase.appMgr.get('GDPR');
    this.title = this.app.i18n._('GDPR');
    this.blacklistContactLabel = new Ext.form.Label({
      text: this.app.i18n._('Must not be contacted')
    });
    this.blacklistContactCheckbox = new Ext.form.Checkbox({
      hideLabel: true,
      disabled: true,
      boxLabel: this.app.i18n._("This Contact withdrawed usage of his data for any purpose."),
      listeners: {
        scope: this,
        check: this.onBlacklistContactCheck
      }
    });
    this.expiryDatePicker = new Ext.ux.form.ClearableDateField({
      fieldLabel: this.app.i18n._('Expiry Date')
    });
    this.expiryDateDescription = new Ext.form.Label({
      style: 'margin-left: 10px; margin-top: 19px; position: absolute;',
      text: this.app.i18n._('Contact gets deleted after this date automatically.')
    });
    this.dataIntendedPurposesGrid = new Tine.widgets.grid.QuickaddGridPanel({
      border: true,
      frame: false,
      recordClass: Tine.GDPR.Model.DataIntendedPurposeRecord,
      columns: ['intendedPurpose', 'agreeDate', 'agreeComment', 'withdrawDate', 'withdrawComment'],
      defaultSortInfo: {
        field: 'agreeDate'
      },
      columnsConfig: {
        agreeComment: {
          width: 200
        },
        withdrawComment: {
          width: 200
        }
      },
      quickaddMandatory: 'intendedPurpose',
      validate: true,
      flex: 1
    });
    this.items = [{
      layout: 'vbox',
      align: 'stretch',
      pack: 'start',
      border: false,
      items: [{
        layout: 'form',
        frame: true,
        //height: 300,
        width: '100%',
        labelAlign: 'top',
        items: [this.blacklistContactLabel, this.blacklistContactCheckbox, {
          layout: 'hbox',
          height: 50,
          layoutConfig: {
            align: 'stretch',
            pack: 'start'
          },
          items: [{
            layout: 'form',
            width: 100,
            items: this.expiryDatePicker
          }, {
            layout: 'form',
            flex: 1,
            items: this.expiryDateDescription
          }]
        }]
      }, this.dataIntendedPurposesGrid]
    }];
    this.supr().initComponent.call(this);
  },
  onRender: function onRender() {
    this.supr().onRender.apply(this, arguments);
    this.editDialog = this.findParentBy(function (c) {
      return c instanceof Tine.Addressbook.ContactEditDialog;
    });
    this.editDialog.on('load', this.onRecordLoad, this);
    this.editDialog.on('recordUpdate', this.onRecordUpdate, this); // NOTE: panel is usually rendered after record was load

    this.onRecordLoad(this.editDialog, this.editDialog.record);
  },
  onBlacklistContactCheck: function onBlacklistContactCheck(cb, checked) {
    if (checked) {
      this.dataIntendedPurposesGrid.getStore().each(function (r) {
        if (!r.get('withdrawDate')) {
          r.set('withdrawDate', new Date());

          if (!r.get('withdrawComment')) {
            r.set('withdrawComment', this.app.i18n._('Blacklist'));
          }
        }
      }, this);
    } else {
      this.dataIntendedPurposesGrid.getStore().each(function (r) {
        Ext.each(['withdrawDate', 'withdrawComment'], function (k) {
          if (r.isModified(k)) {
            r.set(k, r.modified[k]);
          }
        }, this);
      }, this);
    }

    this.dataIntendedPurposesGrid.setReadOnly(checked);
  },
  onRecordLoad: function onRecordLoad(editDialog, record) {
    var _ = window.lodash,
        evalGrants = editDialog.evalGrants,
        container = editDialog.getForm().findField('container_id').selectedRecord,
        hasRequiredGrant = !evalGrants || _.get(container, 'data.account_grants' + '.' + this.requiredGrant),
        blacklistContact = !!+record.get('GDPR_Blacklist'),
        expiryDate = record.get('GDPR_DataExpiryDate');

    this.blacklistContactCheckbox.setValue(blacklistContact);

    if (expiryDate) {
      this.expiryDatePicker.setValue(expiryDate);
    }

    this.dataIntendedPurposesGrid.setStoreFromArray(record.get('GDPR_DataIntendedPurposeRecord') || []);
    this.setReadOnly(!hasRequiredGrant);

    if (blacklistContact) {
      this.dataIntendedPurposesGrid.setReadOnly(true);
    }
  },
  setReadOnly: function setReadOnly(readOnly) {
    this.readOnly = readOnly;
    this.dataIntendedPurposesGrid.setReadOnly(readOnly);
    this.blacklistContactCheckbox.setDisabled(readOnly);
    this.expiryDatePicker.setReadOnly(readOnly);
  },
  onRecordUpdate: function onRecordUpdate(editDialog, record) {
    record.set('GDPR_DataIntendedPurposeRecord', this.dataIntendedPurposesGrid.getFromStoreAsArray());
    record.set('GDPR_Blacklist', this.blacklistContactCheckbox.getValue());
    record.set('GDPR_DataExpiryDate', this.expiryDatePicker.getValue());
  },
  getCanonicalPathSegment: function getCanonicalPathSegment() {
    return ['', this.app.appName, this.canonicalName].join(Tine.Tinebase.CanonicalPath.separator);
  }
});
Ext.ux.ItemRegistry.registerItem('Tine.Addressbook.editDialog.mainTabPanel', Tine.GDPR.Addressbook.ContactGDPRPanel, 20);

/***/ }),

/***/ 60:
/***/ (function(module, exports, __webpack_require__) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 */
__webpack_require__(2054);

__webpack_require__(2055);

__webpack_require__(2056);

/***/ })

}]);